/*!
 * @module vcui.helper.DetailShortcutFloater
 * @license MIT License
 * @description DetailShortcutFloater 컴포넌트
 * @copyright VinylC UID Group
 */
define('ui/detailShortcutFloater', [
    'jquery',
    'vcui'
], function ($, core) {
    "use strict";

    return core.ui('DetailShortcutFloater', {
        bindjQuery: true,
        defaults: {

        },
        initialize: function (el, options) {
            var self = this;

            if (self.supr(el, options) === false) { return; }

            self._bindEvents();
        },
        _bindEvents: function () {
            var self = this;

            //
            self.on('click', '.btn_float', function (e) {
                e.preventDefault();

                self.toggle();

                if (self.isOpened) {
                    $(this).children().text('메뉴 목록 닫기');
                } else {
                    $(this).children().text('메뉴 목록 보기');
                }
            }).on('click', 'ul a', function (e) {
                self.close();

                var $section = $($(this).attr('href'));
                $('.ui_accordion_ex').vcAccordion('expand', $section.index());
            });
        },
        toggle: function () {
            var self = this,
            isClose = self.$el.hasClass('close');

            self[isClose ? 'open' : 'close']();
        },
        open: function () {
            var self = this;

            self.isOpened = true;
            self.$el.removeClass('close').find('ul').css('opacity', 1);

            setTimeout(function () {
                self.docOn('touchstart click', function (e) {
                    if ($.contains(self.el, e.target)) {
                        return;
                    }
                    self.close();
                });
            }, 50);
        },
        close: function () {
            var self = this;

            self.isOpened = false;
            self.$el.addClass('close').find('ul').css('opacity', 0);
            self.docOff('touchstart click');
        }
    })
});