/*!
 * @module vcui.helper.FontsizeToggler
 * @license MIT License
 * @description FontsizeToggler 컴포넌트
 * @copyright VinylC UID Group
 */
define('ui/fontsizeToggler', ['jquery', 'vcui'], function ($, core) {
    "use strict";

    var FontsizeToggler = core.ui('FontsizeToggler', {
        bindjQuery: 'fontsizeToggler',
        initialize: function (el, options) {
            var self = this;

            if (self.supr(el, options) === false) {
                return;
            }

            self._bindEvents();
        },
        _bindEvents: function () {
            var self = this;

            function changeFontSize(type) {
                $(self.options.target).removeClass('big normal').addClass(type);

                self.$el
                    .removeClass('big normal')
                    .addClass(type === 'big' ? 'normal' : 'big')
                    .text(type === 'big' ? '일반보기' : '큰글씨보기');
           }

            self.on('click', function (e) {
                if ($(this).hasClass('big')) {
                    changeFontSize('big');
                    $('meta[name=viewport]').attr('content', 'initial-scale=1.0, width=device-width, user-scalable=yes');
                } else {
                    changeFontSize('normal');
                    $('meta[name=viewport]').attr('content', 'initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, width=device-width, user-scalable=no');
                }
            })
        }
    });

    return FontsizeToggler;
});