/*!
 * @module vcui.helper.ToggleSelectbox
 * @license MIT License
 * @description ToggleSelectbox 컴포넌트
 * @copyright VinylC UID Group
 */
define('ui/toggleSelectbox', ['jquery', 'vcui'], function ($, core) {
    "use strict";

    return core.ui('ToggleSelectbox', {
        bindjQuery: 'toggleSelectbox',
        initialize: function (el, options) {
            var self = this;

            if (self.supr(el, options) === false) {
                return;
            }

            self.$items = $(self.options.itemSelector);
            self._bindEvents();
        },
        _bindEvents: function () {
            var self = this;

            self.on('change', function (e) {
                self.$items.removeClass('on');
                $('#' + this.value).addClass('on');
            });
        }
    });
});